#!/usr/bin/python3

# ## {R2D2919B742E} ##
# ###########################################################################
# What if magic existed?
# What if a place existed where your every thought and dream come to life.
# There is only one catch: it has to be written down.
# Such a place exists, it is called programming.
#    - Scott Taylor Reph, RightThumb.com
# ###########################################################################
# ## {C3P0D40fAe8B} ##
##################################################
import os, sys, time
##################################################
import _rightThumb._construct as __
appDBA = __.clearFocus( __name__, __file__ )
__.appReg = appDBA
def focus( parentApp='', childApp='', reg=True ):
    global appDBA
    f = __.appName( appDBA, parentApp, childApp )
    if reg:
        __.appReg = f
    return f
__.registeredApps.append( focus() )
import _rightThumb._base3 as _
_.load()
##################################################
import _rightThumb._vars as _v
import _rightThumb._string as _str
##################################################

def appSwitches():
    _.switches.register( 'File', '-file' )
    _.switches.register( 'Add', '-add' )
    _.switches.register( 'List', '-list' )
    _.switches.register( 'Ask', '-ask' )


_.autoBackupData = __.setting('receipt-log')
__.releaseAcquiredData = __.setting('receipt-file')
__.myFileLocations_SKIP_VALIDATION = False
__.isRequired_Pipe = False
__.isRequired_Pipe_or_File = False
__.pre_error = False
__.switch_raw = []
# __.switch_raw = [ 'Delim' ]
# __.isRequired_or_List = ['Pipe','Files','Plus']
# __.setting( 'app-switches-raw', [ 'Delim' ] )


_.appInfo[focus()] = {
    # 'app': '7facG-jo0Cxk',
    'file': 'vps-hoth-7i0ZA-7GzGHN-client-docs-omit.py',
    'liveAppName': __.thisApp( __file__ ),
     'description': 'omit docs from client record on website',
        # _.ail(1,'subject')+
        # _.aib('one')+
    'categories': [
                        'website',
                        'app',
                ],
    'usage': [
                        # 'epy another',
                        # 'e nmap',
                        # '',
    ],
    'relatedapps': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'prerequisite': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'examples': [
                        _.hp('p thisApp -file file.txt'),
                        '',
    ],
    'columns': [
                       # { 'name': 'name', 'abbreviation': 'n' },
                       # { 'name': '{1}', 'abbreviation': '{0}', 'sort': '{2}' },
    ],
    'aliases': [
                       # 'this',
                       # 'app',
    ],
    'notes': [
                       # {},
    ],
}

_.appData[focus()] = {
        'start': __.startTime,
        'uuid': '',
        'audit': [],
        'pipe': False,
        'data': {
                    'field': {'sent': [], 'received': [] }, # { 'label': '', 'context': [],  }
                    'table': {'sent': [], 'received': [] }, 
        },
    }



def registerSwitches( argvProcessForce=False ):
    global appDBA
    if not __.appReg == appDBA and appDBA in __.appReg:

        if not __name__ == '__main__':
            _.argvProcess = argvProcessForce
        else:
            _.argvProcess = True

        _.load()
        _.appInfo[__.appReg] = _.appInfo[appDBA]
        _.appData[__.appReg] = _.appData[appDBA]
    __.constructRegistration( _.appInfo[__.appReg]['file'],__.appReg )
    appSwitches()

    _.myFileLocation_Print = False
    # _.switches.trigger( 'Files', _.myFileLocations, vs=True )
    _.switches.trigger( 'Folder', _.myFolderLocations )
    _.switches.trigger( 'URL', _.urlTrigger )
    _.switches.trigger( 'Ago', _.timeAgo )
    _.switches.trigger( 'Duration', _.timeFuture )
    
    _.defaultScriptTriggers()
    _.switches.process()


if not __name__ == '__main__':
    _.argvProcess = False
else:
    _.argvProcess = True

registerSwitches()


def fieldSet( switchName, switchField, switchValue, theFocus=False ):
    if not type( theFocus ) == bool:
        theFocus = theFocus
    _.switches.fieldSet( switchName, switchField, switchValue, theFocus )


if __name__ == '__main__':
    if not sys.stdin.isatty():
        _.setPipeData( sys.stdin.readlines(), __.appReg, clean=True )


_.postLoad( __file__ )

########################################################################################
# START



def action():
    #--> min, architecture {:strict:}
    load()
    global omit

    #--> sw: File Add List Ask

    if _.switches.isActive('Add'):
        for file in _.switches.values('File'):
            omit.append(file)
        _.saveText( omit, _._path )
        return None

    if _.switches.isActive('List') and _.switches.isActive('Ask'):
        index={}
        for i,file in enumerate(omit):
            index[str(i)] = file
            _.pr( i, file )

        ask=input(' > ')


        if ask in index:
            ii = int(ask)
            fi = index[ask]
            _.pr()
            _.pr()
            _.cp( [ 'What would you like to do?' ], 'yellow' )

            _.pr( 1, 'remove file from .log' )
            _.pr( 2, 'delete file' )

            ask=input(' > ')

            if ask == '1' or ask == '2':
                omit.pop(ii)

                if ask == '2':
                    if os.path.isfile(_._doc+fi):
                        _.pr( _._doc+fi )
                        os.unlink( _._doc+fi )
                        _.cp( [ 'deleted:', fi ], 'cyan' )
                    elif os.path.isfile(_._pics+fi):
                        _.pr( _._pics+fi )
                        os.unlink( _._pics+fi )
                        _.cp( [ 'deleted:', fi ], 'cyan' )

                _.saveText( omit, _._path )
        return None
            

    elif _.switches.isActive('List'):
        for i,file in enumerate(omit):
            index[str(i)] = file
            _.pr( file )



    # for i,file in enumerate( omit ):
    #     _.pr(row)



def load():
    global omit
    omit = _.getText( _._path , clean=2 )


_._path='/home/admin/domains/eyeformeta.com/private_html/apps/clients/7i0ZA/gps/data/omit-docs.log'
_._doc='/home/admin/domains/eyeformeta.com/private_html/apps/clients/7i0ZA/gps/data/docs/'
_._pics='/home/admin/domains/eyeformeta.com/private_html/apps/clients/7i0ZA/gps/data/pics/'



########################################################################################
if __name__ == '__main__':
    action()
    __.isExit()





